<?php
/*
_____________________________________________________________________

Mambo Database Maintenance Version 2.0 12/13/2002

This Mambo Administration Add-on should make it easier for
Administrators to maintain their mySQL databases in top condition.

Mambo Site Server v4.0.11 Database Maintenance
Copyright (c) 2002 by James C. Logan (nagolcj@hotmail.com)

Mambo Site Server Open Source Edition Version 4.0.11
Developers: Danny Younes - danny@miro.com.au
Nicole Anderson - nicole@miro.com.au

LICENSE:

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
_____________________________________________________________________
*/

class databaseAdmin {
	function dbStatus($database) {
		echo "<table border=\"0\" align=\"center\" width=\"90%\" cellspacing=\"0\" cellpadding=\"2\">\n";
		echo "	<tr><th colspan=\"2\" class=\"articlehead\">Database Tables Status</th></tr>\n";
		echo "	<tr><td colspan=\"2\">&nbsp;<br>Looking for some information on the state of your tables or when you last checked them? This procedure provides key information on all tables defined to your database.<br>&nbsp;</td></tr>\n";
		$result = $database->openConnectionWithReturn("SHOW TABLE STATUS");
		while ($result2 = mysql_fetch_object($result)) {
			while (list($key, $value) = each ($result2)) {
				if ($key=="Name") {
					echo "	<tr><td colspan=\"2\" class=\"bold\" align=\"center\">$value</td></tr>\n";
				} else {
					echo "	<tr><td align=\"right\" width=\"50%\">$key</td><td width=\"50%\"> : $value</td></tr>\n";
				}
			}
			echo "	<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
		}
		echo "</table>\n";
		mysql_free_result($result);
	}
	
	function dbOptimize($database) {
		echo "<form action=\"index2.php?option=databaseAdmin&task=doOptimize\" method=\"post\">\n";
		echo "<table border=\"0\" align=\"center\" width=\"90%\" cellspacing=\"0\" cellpadding=\"2\">\n";
		echo "	<tr><th class=\"articlehead\">Database Tables Optimization</th></tr>\n";
		echo "	<tr><td><br>During the course of normal use, records can and will be deleted. Deleted records are maintained in a linked list and subsequent INSERT operations reuse old record positions. Running the Optimize Tables routine reclaims the unused space. It is recommended you run this procedure regularily to ensure the best possible performance.<br><br>While the Optimize Tables routine is executing, the original table is readable by other clients. Updates and writes to the table are stalled until the new table is ready. This is done in such a way that all updates are automatically redirected to the new table without any failed updates.<br><br>The Message Type returned should be one of status (normal), error, info, or warning. If a Message Type other than \"status\" and a Message of \"OK\" is returned, you may have to run a repair on the table. Read the Message carefully to determine if this is required.<br>&nbsp;</td></tr>\n";
		echo "	<tr>\n		<td align=\"center\">\n";
		echo "			<select name=\"tables[]\" size=\"10\" MULTIPLE>\n";
		echo "			<option value=\"all\" selected>All Mambo Site Server Tables\n";
		$result = $database->openConnectionWithReturn("SHOW TABLES");
		while ($result2 = mysql_fetch_object($result)) {
			list (,$value) = each ($result2);
			echo "			<option value=\"$value\">$value\n";
		}
		mysql_free_result($result);
		echo "			</select>\n		</td>\n	</tr>\n	<tr>\n";
		echo "		<td align=\"center\">&nbsp;<br><input type=submit value=\"Optimize the Selected Tables\" class=\"button\"></td>\n";
		echo "	</tr>\n</table>\n</form>\n";
	}
	
	function doOptimize($database, $tables) {
		if (!$tables[0]) {
			dbOptimize($database);
			return;
		}
		if ($tables[0] == "all") {
			$result = $database->openConnectionWithReturn("SHOW TABLES");
			while ($result2 = mysql_fetch_object($result)) {
				list (,$value) = each ($result2);
				$toOptimize .= $value . ",";
			}
			mysql_free_result($result);
		} else {
			while (list(, $value) = each ($tables)) {
				$toOptimize .= $value . ",";
			}
		}
		echo "<table border=\"0\" align=\"center\" width=\"90%\" cellspacing=\"0\" cellpadding=\"2\">\n";
		echo "	<tr><th colspan=\"2\" class=\"articlehead\">Database Tables Optimization Results<br>&nbsp;</th></tr>";
		$toOptimize = rtrim($toOptimize,",");
		$result = $database->openConnectionWithReturn("OPTIMIZE TABLE " . $toOptimize);
		while ($result2 = mysql_fetch_object($result)) {
			while (list($key, $value) = each ($result2)) {
				if ($key=="Table") {
					echo "	<tr><td colspan=\"2\" class=\"bold\" align=\"center\">$value</td></tr>\n";
				} else {
					echo "	<tr><td align=\"right\" width=\"50%\">$key</td><td width=\"50%\"> : $value</td></tr>\n";
				}
			}
			echo "	<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
		}
		mysql_free_result($result);
		echo "</table>\n";
	}
	
	function dbAnalyze($database) {
		echo "<form action=\"index2.php?option=databaseAdmin&task=doAnalyze\" method=\"post\">\n";
		echo "<table border=\"0\" align=\"center\" width=\"90%\" cellspacing=\"0\" cellpadding=\"2\">\n";
		echo "	<tr><th class=\"articlehead\">Database Tables Analysis</th></tr>\n";
		echo "	<tr><td><br>Analyze and store the key distribution for the table. MySQL uses the stored key distribution to decide in which order tables should be joined when one does a join on something else than a constant. During the analysis the table is locked with a read lock.<br><br>If a Message Type other than \"status\" and a Message of \"OK\" is returned, you may have to run a repair on the table. Read the Message carefully to determine if this is required.<br>&nbsp;</td></tr>\n";
		echo "	<tr>\n		<td align=\"center\">\n";
		echo "			<select name=\"tables[]\" size=\"10\" MULTIPLE>\n";
		echo "			<option value=\"all\" selected>All Mambo Site Server Tables\n";
		$result = $database->openConnectionWithReturn("SHOW TABLES");
		while ($result2 = mysql_fetch_object($result)) {
			list (,$value) = each ($result2);
			echo "			<option value=\"$value\">$value\n";
		}
		mysql_free_result($result);
		echo "			</select>\n		</td>\n	</tr>\n	<tr>\n";
		echo "		<td align=\"center\">&nbsp;<br><input type=submit value=\"Analyze the Selected Tables\" class=\"button\"></td>\n";
		echo "	</tr>\n</table>\n</form>\n";
	}
	
	function doAnalyze($database, $tables) {
		if (!$tables[0]) {
			$this->dbAnalyze($database);
			return;
		}
		if ($tables[0] == "all") {
			$result = $database->openConnectionWithReturn("SHOW TABLES");
			while ($result2 = mysql_fetch_object($result)) {
				list (,$value) = each ($result2);
				$toAnalyze .= $value . ",";
			}
			mysql_free_result($result);
		} else {
			while (list(, $value) = each ($tables)) {
				$toAnalyze .= $value . ",";
			}
		}
		echo "<table border=\"0\" align=\"center\" width=\"90%\" cellspacing=\"0\" cellpadding=\"2\">\n";
		echo "	<tr><th colspan=\"2\" class=\"articlehead\">Database Tables Analysis Results<br>&nbsp;</th></tr>";
		$toAnalyze = rtrim($toAnalyze,",");
		$result = $database->openConnectionWithReturn("ANALYZE TABLE " . $toAnalyze);
		while ($result2 = mysql_fetch_object($result)) {
			while (list($key, $value) = each ($result2)) {
				if ($key=="Table") {
					echo "	<tr><td colspan=\"2\" class=\"bold\" align=\"center\">$value</td></tr>\n";
				} else {
					echo "	<tr><td align=\"right\" width=\"50%\">$key</td><td width=\"50%\"> : $value</td></tr>\n";
				}
			}
			echo "	<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
		}
		mysql_free_result($result);
		echo "</table>\n";
	}
	
	function dbCheck($database) {
		echo "<form action=\"index2.php?option=databaseAdmin&task=doCheck\" method=\"post\">\n";
		echo "<table border=\"0\" align=\"center\" width=\"90%\" cellspacing=\"0\" cellpadding=\"2\">\n";
		echo "	<tr><th class=\"articlehead\">Database Tables Check</th></tr>\n";
		echo "	<tr><td><br>This routine checks the selected table(s) for errors.<br><br>The Message Type returned should be one of status (normal), error, info, or warning. If a Message Type other than \"status\" and a Message of \"OK\" is returned, you may have to run a repair on the table. Read the Message carefully to determine if this is required.<br>&nbsp;</td></tr>\n";
		echo "	<tr>\n		<td align=\"center\">\n";
		echo "			<select name=\"tables[]\" size=\"10\" MULTIPLE>\n";
		echo "			<option value=\"all\" selected>All Mambo Site Server Tables\n";
		$result = $database->openConnectionWithReturn("SHOW TABLES");
		while ($result2 = mysql_fetch_object($result)) {
			list (,$value) = each ($result2);
			echo "			<option value=\"$value\">$value\n";
		}
		mysql_free_result($result);
		echo "			</select>\n		</td>\n	</tr>\n	<tr>\n";
		echo "		<td align=\"center\">&nbsp;<br><input type=submit value=\"Check the Selected Tables\" class=\"button\"></td>\n";
		echo "	</tr>\n</table>\n</form>\n";
	}
	
	function doCheck($database, $tables) {
		if (!$tables[0]) {
			dbCheck($database);
			return;
		}
		if ($tables[0] == "all") {
			$result = $database->openConnectionWithReturn("SHOW TABLES");
			while ($result2 = mysql_fetch_object($result)) {
				list (,$value) = each ($result2);
				$toCheck .= $value . ",";
			}
			mysql_free_result($result);
		} else {
			while (list(, $value) = each ($tables)) {
				$toCheck .= $value . ",";
			}
		}
		echo "<table border=\"0\" align=\"center\" width=\"90%\" cellspacing=\"0\" cellpadding=\"2\">\n";
		echo "	<tr><th colspan=\"2\" class=\"articlehead\">Database Tables Check Results<br>&nbsp;</th></tr>";
		$toCheck = rtrim($toCheck,",");
		$result = $database->openConnectionWithReturn("CHECK TABLE " . $toCheck);
		while ($result2 = mysql_fetch_object($result)) {
			while (list($key, $value) = each ($result2)) {
				if ($key=="Table") {
					echo "	<tr><td colspan=\"2\" class=\"bold\" align=\"center\">$value</td></tr>\n";
				} else {
					echo "	<tr><td align=\"right\" width=\"50%\">$key</td><td width=\"50%\"> : $value</td></tr>\n";
				}
			}
			echo "	<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
		}
		mysql_free_result($result);
		echo "</table>\n";
	}
	
	function dbRepair($database) {
		echo "<form action=\"index2.php?option=databaseAdmin&task=doRepair\" method=\"post\">\n";
		echo "<table border=\"0\" align=\"center\" width=\"90%\" cellspacing=\"0\" cellpadding=\"2\">\n";
		echo "	<tr><th class=\"articlehead\">Database Tables Repair</th></tr>\n";
		echo "	<tr><td><br>If any of the regular diagnostic routines (Check, Analyze, or Optimize Tables) returns a Message other than \"OK\", this procedure can be used to attempt to correct the corrupted table.<br><br>The Message Type returned should be one of status (normal), error, info, or warning. If a Message Type other than \"status\" and a Message of \"OK\" is returned, you should try repairing the table with myisamchk -o, as Repair Tables does not yet implement all the options of myisamchk. Please refer to the documentation provided with your MySQL installation for further instructions.<br>&nbsp;</td></tr>\n";
		echo "	<tr>\n		<td align=\"center\">\n";
		echo "			<select name=\"tables[]\" size=\"10\" MULTIPLE>\n";
		echo "			<option value=\"all\" selected>All Mambo Site Server Tables\n";
		$result = $database->openConnectionWithReturn("SHOW TABLES");
		while ($result2 = mysql_fetch_object($result)) {
			list (,$value) = each ($result2);
			echo "			<option value=\"$value\">$value\n";
		}
		mysql_free_result($result);
		echo "			</select>\n		</td>\n	</tr>\n	<tr>\n";
		echo "		<td align=\"center\">&nbsp;<br><input type=submit value=\"Repair the Selected Tables\" class=\"button\"></td>\n";
		echo "	</tr>\n</table>\n</form>\n";
	}
	
	function doRepair($database, $tables) {
		if (!$tables[0]) {
			dbRepair($database);
			return;
		}
		if ($tables[0] == "all") {
			$result = $database->openConnectionWithReturn("SHOW TABLES");
			while ($result2 = mysql_fetch_object($result)) {
				list (,$value) = each ($result2);
				$toRepair .= $value . ",";
			}
			mysql_free_result($result);
		} else {
			while (list(, $value) = each ($tables)) {
				$toRepair .= $value . ",";
			}
		}
		echo "<table border=\"0\" align=\"center\" width=\"90%\" cellspacing=\"0\" cellpadding=\"2\">\n";
		echo "	<tr><th colspan=\"2\" class=\"articlehead\">Database Tables Repair Results</th></tr>";
		$toRepair = rtrim($toRepair,",");
		$result = $database->openConnectionWithReturn("REPAIR TABLE " . $toRepair);
		while ($result2 = mysql_fetch_object($result)) {
			while (list($key, $value) = each ($result2)) {
				if ($key=="Table") {
					echo "	<tr><td colspan=\"2\" class=\"bold\" align=\"center\">$value</td></tr>\n";
				} else {
					echo "	<tr><td align=\"right\" width=\"50%\">$key</td><td width=\"50%\"> : $value</td></tr>\n";
				}
			}
			echo "	<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
		}
		mysql_free_result($result);
		echo "</table>\n";
	}
	
	function dbBackup($database) {
		echo "<form action=\"index2.php?option=databaseAdmin&task=doBackup\" method=\"post\">\n";
		echo "<table border=\"0\" align=\"center\" cellspacing=\"0\" cellpadding=\"2\">\n";
		echo "	<tr><th class=\"articlehead\">Database Tables Backup</th></tr>\n";
		echo "	<tr>\n		<td>\n";
		echo "			<p>&nbsp;<br>Where would you like to back up your Database Tables to?<br>&nbsp;<br>\n";
		echo "			<input type='radio' name=\"OutDest\" value=\"screen\">Display Results on the Screen<br>\n";
		echo "			<input type='radio' name=\"OutDest\" value=\"remote\" checked>Download to a file on my local computer<br>\n";
		echo "			<input type='radio' name=\"OutDest\" value=\"local\">Store the file in the backup directory on the server<br>&nbsp;</p>\n";
		echo "			<p>What format would you like to save them as?<br>&nbsp;<br>\n";
		echo "			<input type='radio' name=\"OutType\" value=\"sql\" checked>As a SQL (plain text) file<br>\n";
		if (function_exists('gzcompress')) echo "			<input type='radio' name=\"OutType\" value=\"zip\">As a Zip file<br>\n";
		if (function_exists('bzcompress')) echo "			<input type='radio' name=\"OutType\" value=\"bzip\">As a BZip file<br>\n";
		if (function_exists('gzencode')) echo "			<input type='radio' name=\"OutType\" value=\"gzip\">As a GZip file<br>\n";
		echo "			&nbsp;</p></td>\n	</tr>\n";
		echo "	<tr>\n		<td align=\"center\">\n";
		echo "			<p align=\"left\">Which Database Tables would you like to back up?<br>Please note, it is highly recommended you select ALL your tables.</p>\n";
		echo "			<select name=\"tables[]\" size=\"5\" MULTIPLE>\n";
		echo "			<option value=\"all\" selected>All Mambo Site Server Tables\n";
		$result = $database->openConnectionWithReturn("SHOW TABLES");
		while ($result2 = mysql_fetch_object($result)) {
			list (,$value) = each ($result2);
			echo "			<option value=\"$value\">$value\n";
		}
		mysql_free_result($result);
		echo "			</select>\n		</td>\n	</tr>\n	<tr>\n";
		echo "		<td align=\"center\">&nbsp;<br><input type=submit value=\"Backup the Selected Tables\" class=\"button\"></td>\n";
		echo "	</tr>\n</table>\n</form>\n";
	}
	
	function doBackup($database, $tables, $OutType, $OutDest) {
		if (!$tables[0]) {
			echo "<p class=\"componentHeading\">Error! No database table(s) specified. Please select at least one table and re-try.</p>\n";
			$this->dbBackup($database);
			return;
		}
		
		/* Need to know what browser the user has to accomodate nonstandard headers */
		
		$HTTP_USER_AGENT = '';
		$UserBrowser = '';
		
		if (!empty($_SERVER['HTTP_USER_AGENT'])) {
			$HTTP_USER_AGENT = $_SERVER['HTTP_USER_AGENT'];
		} else if (!empty($HTTP_SERVER_VARS['HTTP_USER_AGENT'])) {
			$HTTP_USER_AGENT = $HTTP_SERVER_VARS['HTTP_USER_AGENT'];
		}
		
		if (ereg('Opera(/| )([0-9].[0-9]{1,2})', $HTTP_USER_AGENT)) {
			$UserBrowser = "Opera";
		} else if (ereg('MSIE ([0-9].[0-9]{1,2})', $HTTP_USER_AGENT)) {
			$UserBrowser = "IE";
		}
		
		/* Determine the mime type and file extension for the output file */
		
		if ($OutType == "bzip") :
		$ext = 'bz2';
		$mime_type = 'application/x-bzip';
		elseif ($OutType == "gzip") :
		$ext = 'gz';
		$mime_type = 'application/x-gzip';
		elseif ($OutType == "zip") :
		$ext = 'zip';
		$mime_type = 'application/x-zip';
		else :
		$ext = 'sql';
		$mime_type = ($UserBrowser == 'IE' || $UserBrowser == 'Opera') ? 'application/octetstream' : 'application/octet-stream';
		endif;
		
		/* Store all the tables we want to back-up in variable $tables[] */
		
		if ($tables[0] == "all") {
			array_pop($tables);
			$query1 = $database->openConnectionWithReturn("SHOW TABLES");
			while ($result1 = mysql_fetch_object($query1)) {
				list(,$tables[]) = each($result1);
			}
			mysql_free_result($query1);
		}
		
		/* Store the "Create Tables" SQL in variable $CreateTable[$tblval] */
		
		foreach ($tables as $tblval) {
			$query2 = $database->openConnectionWithReturn("SHOW CREATE TABLE $tblval");
			while ($result2 = mysql_fetch_array($query2)) {
				$CreateTable[$tblval] = $result2;
			}
		}
		mysql_free_result($query2);
		
		/* Store all the FIELD TYPES being backed-up (text fields need to be delimited) in variable $FieldType*/
		
		foreach ($tables as $tblval) {
			$query3 = $database->openConnectionWithReturn("SHOW FIELDS FROM $tblval");
			while ($result3 = mysql_fetch_row($query3)) {
				$FieldType[$tblval][$result3[0]] = preg_replace("/[(0-9)]/",'', $result3[1]);
			}
		}
		mysql_free_result($query3);
		
		/* Build the fancy header on the dump file */
		
		include ("../configuration.php");
		$OutBuffer = "#\n";
		$OutBuffer .= "# Mambo Site Server v4.011 MySQL-Dump\n";
		$OutBuffer .= "# version 2.0\n";
		$OutBuffer .= "# http://www.mamboserver.com\n";
		$OutBuffer .= "#\n";
		$OutBuffer .= "# Host: $host\n";
		$OutBuffer .= "# Generation Time: " . date("M j, Y \a\\t H:i") . "\n";
		$OutBuffer .= "# Server version: " . mysql_get_server_info() . "\n";
		$OutBuffer .= "# PHP Version: " . phpversion() . "\n";
		$OutBuffer .= "# Database : `" . $db . "`\n";
		$filename = $db . "_" . date("jmYHis");
		
		/* Okay, here's the meat & potatoes */
		
		foreach ($tables as $tblval) {
			$OutBuffer .= "# --------------------------------------------------------\n\n#\n# Table structure for table `$tblval`\n#\nDROP TABLE IF EXISTS $tblval;\n" . $CreateTable[$tblval][1] . ";\n";
			$OutBuffer .= "\n#\n# Dumping data for table `$tblval`\n#\n\n";
			$query4 = $database->openConnectionWithReturn("SELECT * FROM $tblval");
			while ($result4 = mysql_fetch_object($query4)) {
				$InsertDump = "INSERT INTO $tblval VALUES (";
				while (list($key, $value) = each ($result4)) {
					if (preg_match ("/\b" . $FieldType[$tblval][$key] . "\b/i", "DATE TIME DATETIME CHAR VARCHAR TEXT TINYTEXT MEDIUMTEXT LONGTEXT BLOB TINYBLOB MEDIUMBLOB LONGBLOB ENUM SET")) {
						$InsertDump .= "'" . addslashes($value) . "',";
					} else {
						$InsertDump .= "$value,";
					}
				}
				$OutBuffer .= rtrim($InsertDump,',') . ");\n";
			}
			mysql_free_result($query4);
		}
		
		/* Send the HTML headers */
		if ($OutDest == "remote") {
			header('Content-Type: ' . $mime_type);
			header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');
			if ($UserBrowser == 'IE') {
				header('Content-Disposition: inline; filename="' . $filename . '.' . $ext . '"');
				header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
				header('Pragma: public');
			} else {
				header('Content-Disposition: attachment; filename="' . $filename . '.' . $ext . '"');
				header('Pragma: no-cache');
			}
		}
		
		if ($OutDest == "screen") :
		$OutBuffer = str_replace("<","&lt;",$OutBuffer);
		$OutBuffer = str_replace(">","&gt;",$OutBuffer);
		echo "<pre>" . $OutBuffer . "</pre>";
		elseif ($OutType == "sql") :
		if ($OutDest == "local") :
		$this->dbBackup($database);
		$fp = fopen("$local_backup_path/$filename.$ext", "w");
		if (!$fp) :
		echo "<p align=\"center\"  class=\"bold\">&nbsp;<br>Database backup FAILURE!!<br>File $local_backup_path/$filename.$ext not writable<br>Please contact your admin/webmaster!<br>&nbsp;</p>";
		else :
		fwrite($fp, $OutBuffer);
		fclose($fp);
		echo "<p align=\"center\"  class=\"bold\">&nbsp;<br>Database backup successful! Your file was saved on the server in directory :<br>$local_backup_path/$filename.$ext<br>&nbsp;</p>";
		endif;
		else :
		echo $OutBuffer;
		endif;
		elseif ($OutType == "bzip") :
		if (function_exists('bzcompress')) :
		if ($OutDest == "local") :
		$this->dbBackup($database);
		$fp = fopen("$local_backup_path/$filename.$ext", "wb");
		if (!$fp) :
		echo "<p align=\"center\"  class=\"bold\">&nbsp;<br>Database backup FAILURE!!<br>File $local_backup_path/$filename.$ext not writable<br>Please contact your admin/webmaster!<br>&nbsp;</p>";
		else :
		fwrite($fp, bzcompress($OutBuffer));
		fclose($fp);
		echo "<p align=\"center\"  class=\"bold\">&nbsp;<br>Database backup successful! Your file was saved on the server in directory :<br>$local_backup_path/$filename.$ext<br>&nbsp;</p>";
		endif;
		else :
		echo bzcompress($OutBuffer);
		endif;
		else :
		echo $OutBuffer;
		endif;
		elseif ($OutType == "gzip") :
		if (function_exists('gzencode')) :
		if ($OutDest == "local") :
		$this->dbBackup($database);
		$fp = fopen("$local_backup_path/$filename.$ext", "wb");
		if (!$fp) :
		echo "<p align=\"center\"  class=\"bold\">&nbsp;<br>Database backup FAILURE!!<br>File $local_backup_path/$filename.$ext not writable<br>Please contact your admin/webmaster!<br>&nbsp;</p>";
		else :
		fwrite($fp, gzencode($OutBuffer));
		fclose($fp);
		echo "<p align=\"center\"  class=\"bold\">&nbsp;<br>Database backup successful! Your file was saved on the server in directory :<br>$local_backup_path/$filename.$ext<br>&nbsp;</p>";
		endif;
		else :
		echo gzencode($OutBuffer);
		endif;
		else :
		echo $OutBuffer;
		endif;
		elseif ($OutType == "zip") :
		if (function_exists('gzcompress')) :
		include "classes/zip.lib.php";
		$zipfile = new zipfile();
		$zipfile -> addFile($OutBuffer, $filename . ".sql");
		if ($OutDest == "local") :
		$this->dbBackup($database);
		$fp = fopen("$local_backup_path/$filename.$ext", "wb");
		if (!$fp) :
		echo "<p align=\"center\"  class=\"bold\">&nbsp;<br>Database backup FAILURE!!<br>File $local_backup_path/$filename.$ext not writable<br>Please contact your admin/webmaster!<br>&nbsp;</p>";
		else :
		fwrite($fp, $zipfile->file());
		fclose($fp);
		echo "<p align=\"center\"  class=\"bold\">&nbsp;<br>Database backup successful! Your file was saved on the server in directory :<br>$local_backup_path/$filename.$ext<br>&nbsp;</p>";
		endif;
		else :
		echo $zipfile->file();
		endif;
		else :
		echo $OutBuffer;
		endif;
		endif;
	}
	
	function dbRestore($database) {
		/* restore screen here */
	}
	
	function doRestore($database, $tables, $InputType, $InputOrig) {
		/* restore process here */
	}
}

?>
